from __future__ import division
from mpl_toolkits.mplot3d import Axes3D
from matplotlib.mlab import griddata
import matplotlib.pyplot as plt
import numpy as np

fig = plt.figure(figsize=(9,9))
ax = fig.add_subplot(111, projection='3d', azim=0, elev=90)

u = np.linspace(0, 2 * np.pi, 100)
v = np.linspace(0, np.pi, 100)

x = 10 * np.outer(np.cos(u), np.sin(v))
y = 10 * np.outer(np.sin(u), np.sin(v))
z = 10 * np.outer(np.ones(np.size(u)), np.cos(v))
ax.plot_surface(x, y, z,  rstride=10, cstride=10, lw=0.1, color='r', alpha=0.1)
#ax.plot([-20,20],[0,0],[0,0],'k-',lw=2)
#ax.plot([0,0],[-20,20],[0,0],'k-',lw=2)
#ax.plot([0,0],[0,0],[-20,20],'k-',lw=2)

#ax.plot([5],[5],5,'bs',markersize=10, alpha=0.9)
ax.plot([0],[15],0,'ks',markersize=10,alpha=0.9)


u1 = np.linspace(45/180*np.pi, 60/180*np.pi, 100)
v1 = np.linspace(40/180*np.pi, 55/180*np.pi, 100)

X1 = 9 * np.outer(np.cos(u1), np.sin(v1))
Y1 = 9 * np.outer(np.sin(u1), np.sin(v1))
Z1 = 9 * np.outer(np.ones(np.size(u1)), np.cos(v1))

X2 = 9.1 * np.outer(np.cos(u1), np.sin(v1))
Y2 = 9.1 * np.outer(np.sin(u1), np.sin(v1))
Z2 = 9.1 * np.outer(np.ones(np.size(u1)), np.cos(v1))


# theta = 45/180*np.pi
# phi = 10/180*np.pi
# dtheta = 5/180*np.pi
# dphi = 5/180*np.pi
# r = 1
# dr = 0.1
# 
# x1 = np.array([r*np.sin(theta+dtheta)*np.cos(phi), r*np.sin(theta+dtheta)*np.cos(phi+dphi),
#       r*np.sin(theta)*np.cos(phi), r*np.sin(theta)*np.cos(phi+dphi),
#       (r+dr)*np.sin(theta+dtheta)*np.cos(phi), (r+dr)*np.sin(theta+dtheta)*np.cos(phi+dphi),
#       (r+dr)*np.sin(theta)*np.cos(phi), (r+dr)*np.sin(theta)*np.cos(phi+dphi)])
# 
# y1 = np.array([r*np.sin(theta+dtheta)*np.sin(phi), r*np.sin(theta+dtheta)*np.sin(phi+dphi),
#       r*np.sin(theta)*np.sin(phi), r*np.sin(theta)*np.sin(phi+dphi),
#       (r+dr)*np.sin(theta+dtheta)*np.sin(phi), (r+dr)*np.sin(theta+dtheta)*np.sin(phi+dphi),
#       (r+dr)*np.sin(theta)*np.sin(phi), (r+dr)*np.sin(theta)*np.sin(phi+dphi)])
# 
# z1 = np.array([r*np.cos(theta+dtheta), r*np.cos(theta+dtheta),
#       r*np.cos(theta), r*np.cos(theta),
#       (r+dr)*np.cos(theta+dtheta), (r+dr)*np.cos(theta+dtheta),
#       (r+dr)*np.cos(theta), (r+dr)*np.cos(theta)])
# 
# xi = np.linspace(min(x1), max(x1))
# yi = np.linspace(min(y1), max(y1))
# 
# X1, Y1 = np.meshgrid(xi, yi)
# Z1 = griddata(x1, y1, z1, xi, yi)
# 
# 
ax.plot_surface(X1, Y1, Z1,  rstride=5, cstride=5, lw=0.25, color='b', alpha=1)
ax.plot_surface(X2, Y2, Z2,  rstride=5, cstride=5, lw=0.25, color='b', alpha=1)

lim=20

ax.set_xlim3d([-lim,lim])
ax.set_ylim3d([-lim,lim])
ax.set_zlim3d([-lim,lim])

for a in ax.w_xaxis.get_ticklines()+ax.w_xaxis.get_ticklabels(): 
    a.set_visible(False) 

for a in ax.w_yaxis.get_ticklines()+ax.w_yaxis.get_ticklabels(): 
    a.set_visible(False) 
    
for a in ax.w_zaxis.get_ticklines()+ax.w_zaxis.get_ticklabels(): 
    a.set_visible(False) 

ax.set_xlabel('X')
ax.set_ylabel('Y')
ax.set_zlabel('Z')


plt.savefig('sphere_top.pdf')
#plt.show()
